function pop = create_population(NVARS,FitnessFcn,options,Neighbor)
%CREATE_POPULATION Creates a population of chromosome.
%   POP = CREATE_POPULATION(NVARS,FITNESSFCN,OPTIONS,Neighbor) creates a population
%  POP each element being an array of length NVARS. Each array 
%  is initialized with a neighbor j of node i  
%

totalPopulationSize = sum(options.PopulationSize);
pop = zeros(totalPopulationSize,NVARS);
rand('twister',sum(1000*clock));
for i = 1:totalPopulationSize
     chrom = fix(NVARS*rand(NVARS,1))+1;
    for k=1:NVARS
        position = ceil(size(Neighbor{k},2)*rand);
        chrom(k)= Neighbor{k}(position);
    end
     pop(i,:) = chrom;
end

end