


function [maxNMI, mod1, fru1, minFru, mod2, nmi2, maxMod, fru3, nmi3, mod, fru, nmi, pareto, CM, class] = mainMOEA(edgesGraph, classi, numNegEdges, Generations, PopulationSize, crossoverFraction,mutationRate);


    
numclassi= length(unique(classi(:,2)))

[Neighbor numEdges numberOfVariables] = builAdjList1(edgesGraph)





[x,fval,reason,output,population,scores] =MOEAcluster(Generations,PopulationSize,crossoverFraction,mutationRate,numberOfVariables, numEdges, Neighbor, numNegEdges);

%delete duplicate solutions

duplicates=ones(size(x,1),1);


for i=1:size(x,1)
    
    for j=i+1:size(x,1)
        if (fval(i,1) == fval(j,1) && fval(i,2) == fval(j,2))
            duplicates(j,1)=0;
        end
    end
end


  c2=fval(:,1);
  c1=fval(:,2);
% % 
  figure
  scatter(c1,c2,'filled')
  xlabel('frustration')
  ylabel('modularity')


risultato=zeros(1,5);
j=1;
for i=1:size(x,1)
    
    if (duplicates(i,1) ==1)
       % disp('solution number: ') 
        %i
      
       CC=decodenew(x(i,:));

       
     if(size(CC,2)>1) 
       pareto{j}=CC;
   
      
     
   %  if knownclass == 1
         CM=confusionMatrix(CC,classi,numclassi); %genera la matrice di confusione 
         NMI = computeNMI(CM,numberOfVariables); 
         risultato(j,4)=NMI;
  %   end
     
     
  
    risultato(j,3)=size(CC,2);
    risultato(j,5)=i;
    risultato(j,1)=fval(i,1); % modularity
    risultato(j,2)=fval(i,2); % frustration
    
   j=j+1;
     end
    end
end


[fid, message] = fopen('ris.txt','wt');
fprintf(fid,'modularity    frustration size     NMI     Num.\n');
for i1 = 1:size(risultato,1)
    for j1= 1:5
       
            fprintf(fid,'%d     ',risultato(i1,j1));
    end
    fprintf(fid,'\n');
end

%prendo massima NMI e corrispondente frustrazione e modularit?
 [maxNMI indMaxNMI] = max(risultato(:,4));
 mod1 = -risultato(indMaxNMI,1);
 fru1 = risultato(indMaxNMI,2);

  fprintf(fid,'\n max NMI= %d and the corresponding frustration %d  and modularity  values %d     \n',maxNMI,fru1, mod1);
%prendo min frustration e corrispondente mod e nmi
[minFru indMinFru] = min(risultato(:,2));
mod2 = -risultato(indMinFru,1);
nmi2 = risultato(indMinFru,4);

fprintf(fid,'\n min frustration= %d and the corresponding modularity %d  and NMI  values %d     \n',minFru,mod2, nmi2);

%prendo massima modularit? e corrispondente frustrazione e nmi
%prendo min frustration e corrispondente mod e nmi
[maxMod indMaxMod] = min(risultato(:,1));
fru3 = risultato(indMaxMod,2);
nmi3 = risultato(indMaxMod,4);
maxMod = -maxMod;

 fprintf(fid,'\n max modularity= %d and the corresponding frustration %d  and NMI  values %d     \n',maxMod,fru3, nmi3);

%a questo punto dobbiamo ricavarci il class della soluzione a max mod
%e poi su questo operare per spostare i nodi nelle classi
% in base al guadagno in mod

bestCC= pareto{indMaxMod};
CM=confusionMatrix(bestCC,classi,numclassi);
  
% % bestNMI = risultato(indMinFru,4);
% % 
class=zeros(numberOfVariables,2);

   for k=1:size(bestCC,2)
     listnodes=bestCC{k};
     for j=1 : size(listnodes,2)
        class(listnodes(1,j),2)=k;%vettore delle classi trovate per ogni nodo
        class(listnodes(1,j),1)=listnodes(1,j); %nella posizione data dal nodo
        %corrente listnodes(1,j) ci mettiamo il nodo stesso
     end   %bestCC{k}
   end
%    
matrix = createMatrix(edgesGraph, numberOfVariables);
%initial_fru = fru3 / (sum(sum(abs(matrix(:,:))),2))

class1 = Copy_of_localOptimize2(class, Neighbor, matrix);

classUnique = unique(class1(:,2));
for s=1:size(classUnique,1)
    CC_new{s}=class1(find(class1(:,2)==classUnique(s)),1)';
end

mod = computeModularitySigned(CC_new, Neighbor,numEdges, numberOfVariables)
%mod = compute_modularity(class1(:,2),matrix);

if(mod > maxMod)
    
    
    fru = compute_frustration(CC_new, Neighbor, numberOfVariables);

    CM=confusionMatrix(CC_new,classi,numclassi); %genera la matrice di confusione 
    nmi = computeNMI(CM,numberOfVariables);
 
    class=class1;
else
    mod = maxMod;
    fru = fru3;
    nmi = nmi3;
end


fprintf(fid,'\n max modularity= %d and the corresponding frustration %d  and NMI  values %d  after local search   \n',mod,fru, nmi);

clear matrix;

end

