


function  [x,fval,reason,output,population,scores]=MOEAcluster(gen,popSize,CrossoverFraction,mutationRate,numberOfVariables, numEdges, Neighbor, numNegEdges)


    %'PlotFcn', {@plotfun,@gaplotscores,@gaplotpareto,@gaplotscorediversity}, ...

FitnessFcn = @(x)MOcluster_fitness(x,numEdges,Neighbor, numberOfVariables, numNegEdges);

options = gaoptimset('PopulationType', 'custom','PopInitRange', ...
    [1;numberOfVariables]);

Elitecount=(options.PopulationSize*10)/100;

options = gaoptimset(options,'CreationFcn',{@create_population, Neighbor}, ...
    'CrossoverFcn',{@crossover_cluster},...
    'MutationFcn',{@mutate_cluster, mutationRate,Neighbor}, ...
    'SelectionFcn',@selectiontournament, ...
    'Generations',gen,'PopulationSize',popSize, ...
    'StallTimeLimit',Inf, ...
    'StallGenLimit',10,'Vectorized','off',...
    'UseParallel','always');

lb=[];

ub=[];
tic
[x,fval,reason,output,population,scores] = gamultiobj(FitnessFcn,numberOfVariables,[],[],[],[],lb,ub,options);

time=toc;



