
function [Neighbor numOfEdges numberOfVariables] = builAdjList1(Edges)

%costruisce la lista di adiacenza di ogni nodo calcolando l'elenco dei vicini
%struttura in cui ogni elemento in pos k contiene due liste
%1) la lista dei vicini del nodo k in pos (k,1)
%2) la lista dei segni associati a ogni arco dei vicini in pos (k,2)

%Edges = renameVertices(Edges1);

numberOfVariables=max(max(Edges(:,1)),max(Edges(:,2)));


for k=1:numberOfVariables
 
    Neighbor{k,1} = [];
    Neighbor{k,2} = [];
end

for i=1:size(Edges,1) %per ogni arco (i,j) memorizza in neighbor(i) il nodo j 
    
      V = Neighbor{Edges(i,1),1};
      found = size(find(V==(Edges(i,2))),2);
%      
      if(found==0)
    
            Neighbor{Edges(i,1),1} = [Neighbor{Edges(i,1),1} Edges(i,2)];% Edges(i,3)];
            Neighbor{Edges(i,1),2} = [Neighbor{Edges(i,1),2} Edges(i,3)];
            
            
      end
%      
      V = Neighbor{Edges(i,2),1};
      found = size(find(V==(Edges(i,1))),2);
%      
      if(found==0)
%     
             Neighbor{Edges(i,2),1} =[Neighbor{Edges(i,2),1} Edges(i,1)];% Edges(i,3)];
             Neighbor{Edges(i,2),2} = [Neighbor{Edges(i,2),2} Edges(i,3)];
      end
      
  
end



numOfEdges = size(Edges(:,2),1)


end