function mod = computeModularitySigned(CC, Neighbor, numEdges, numberofVariables )
mod=0;
    for nCC=1:size(CC,2)
                                             %che formano la componente corrente
            listnodes=CC{nCC};
             ds_pos=0;
             ds_neg=0;
             
             ls = 0;
       
             for j=1:size(listnodes,2)
               
                currnode=listnodes(1,j);
                
                %vicini correnti con segno
                neighborCN = Neighbor{currnode,1};
                signes = Neighbor{currnode,2};
                
                %creo il vettore che corrisponde a una riga della matrice
                %di adiacenza
                
                V = zeros(1,numberofVariables);
                
                V(neighborCN)=signes;
      
                ls = ls + sum(V(listnodes)); %ls totale
            
                ds_pos = ds_pos + sum(V > 0); %ds solo su archi pos
                ds_neg= ds_neg + sum(abs(V < 0)); %ds solo su archi neg              
                
                clear V;
             end 
           
             mod = mod + ls/numEdges + (ds_neg/numEdges)^2 - (ds_pos/numEdges)^2;  % signed modularity

        end

end

