function score = compute_frustration(CC, Neighbor, numberofVariables)
         
         score=0;
         
         for nCC=1:size(CC,2)
                                             
            listnodes=CC{nCC};
             ls_pos=0;
             ds_pos=0;
             
             ls_neg=0;
       
             for j=1:size(listnodes,2)
               
                currnode=listnodes(1,j);
                
                %vicini correnti con segno
                neighborCN = Neighbor{currnode,1};
                signes = Neighbor{currnode,2};
                
                %creo il vettore che corrisponde a una riga della matrice
                %di adiacenza
                
                V = zeros(1,numberofVariables);
                
                V(neighborCN)=signes;
            
                ls_neg = ls_neg + sum(abs(V(listnodes)<0)); %ls negativo
                ls_pos = ls_pos + sum(V(listnodes)>0); %ls positivo
            
                ds_pos = ds_pos + sum(V > 0); %ds solo su archi pos
                          
                
                clear V;
                

             end 
             cs_pos = ds_pos - ls_pos; % cs positivo
            
             gainFitt = ls_neg + cs_pos;   % signed frustration
             score=score + gainFitt;
                  
        end
end